/******************************************************************************
 *
 * Extension of AMDiS - Adaptive multidimensional simulations
 *
 * Copyright (C) 2013 Dresden University of Technology. All Rights Reserved.
 * Web: https://fusionforge.zih.tu-dresden.de/projects/amdis
 *
 * Authors: Simon Praetorius et al.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 *
 * See also license.opensource.txt in the distribution.
 * 
 ******************************************************************************/

#ifndef AMDIS_PETSC_PRECON_PFC_H
#define AMDIS_PETSC_PRECON_PFC_H

#include "solver/PetscSolver.h"

namespace AMDiS {

  using namespace std;

  struct PfcData {
    KSP kspM, kspM2, kspMpK, kspSchur;
    Mat matM, matK;
    double delta, tau;
  };

  class PetscPreconPfc : public PetscRunner
  {
  public:
    PetscPreconPfc(LinearSolver* oem_)
    : PetscRunner(oem_),
      tau(NULL)
    { }

    void setData(double *tauPtr)
    {
      tau = tauPtr;
    }

    void init(const BlockMatrix& A, const Mat& fullMatrix);
    void exit();

  private:
    Mat MpK;
    Mat matSchur;
    PfcData data;

    double *tau;
  };

}

#endif // AMDIS_PETSC_PRECON_PFC_H
